/*
    Copyright (C) 1992-1994
                    Welson R. Jacometti

    All rights reserved.

    This program is  free software; you can redistribute unmodified
    versions of it as long as you do not  profit from that, neither
    by selling it nor  by   including it  with other products   for
    sale.  This copyright  notice  must  remain in all  distributed
    copies.

    You are  allowed to modify your  personal copy  of this program
    (as long as you do not distribute any changed versions).

    You may,  of course, distribute  along with it, your own source
    code or libraries of algorithms that run under GeoLab.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.

    If you must contact the authors, you may write to:
                     geolab-request@dcc.unicamp.br
*/

/*
 *
 * Boolean.C - Boolean & GraphicBoolean methods.
 *
 *
 *    	Data	Hora  	Nome     		Modificacao/Motivo
 *
 *    20.01.92  13:40 	Welson R. Jacometti  	Arquivo criado
 *
 */

#include "Obj.h"
#include "Boolean.h"

GraphicObj* Boolean::new_GraphicObj() {
    return new GraphicBoolean(this);
}

void Boolean::draw(World *w, GC)  {
    Frame frame = (Frame)xv_get(w->get_canvas(), XV_OWNER);
    xv_set(frame, FRAME_RIGHT_FOOTER, (val ? "TRUE" : "FALSE"), NULL);
}

/*
 *
 * GraphicBoolean methods
 *
 *
 */

// cast macro

#define boolean	((Boolean *)obj)
 
void GraphicBoolean::draw(World *w, DrawMode) {
    boolean->draw(w);    
}



