/*
    Copyright (C) 1992-1994
                    Welson R. Jacometti

    All rights reserved.

    This program is  free software; you can redistribute unmodified
    versions of it as long as you do not  profit from that, neither
    by selling it nor  by   including it  with other products   for
    sale.  This copyright  notice  must  remain in all  distributed
    copies.

    You are  allowed to modify your  personal copy  of this program
    (as long as you do not distribute any changed versions).

    You may,  of course, distribute  along with it, your own source
    code or libraries of algorithms that run under GeoLab.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.

    If you must contact the authors, you may write to:
                     geolab-request@dcc.unicamp.br
*/

/*
 * GraphicDemo.h
 *
 *
 *    	Data	Hora  	Nome     		Modificacao/Motivo
 *
 *    21.10.92  13:40 	Welson R. Jacometti   	Arquivo criado
 *
 */

#ifndef _GRAPHICDEMO_DEFINED
#define _GRAPHICDEMO_DEFINED

#include "External.h"		// obrigatorio a todo modulo externo
#include "Algorithm.h"

class GraphicDemoReset : public Algorithm {
    bool is_able_to_handle(const SelectedObjects &, const GraphicObjects &);
   ResultObjects binder(const SelectedObjects &, const GraphicObjects &, World *, int, int);
};

class GraphicDemoRecord : public Algorithm {
    bool is_able_to_handle(const SelectedObjects &, const GraphicObjects &);
    ResultObjects binder(const SelectedObjects &, const GraphicObjects &, World *, int, int);
};

class GraphicDemoPlay : public ExternalFunctionMode {
    void activator(World *);
    icon_bits *icon();
    virtual bool capture_events() {return false;}
    bool is_able_to_activate(const SelectedObjects &, const GraphicObjects &, World *);
};

Algorithm* GraphicDemoReset_link();
Algorithm* GraphicDemoRecord_link();
Algorithm* GraphicDemoPlay_link();

#endif ~_GRAPHICDEMO_DEFINED;

