/*
    Copyright (C) 1992-1994
                    Welson R. Jacometti

    All rights reserved.

    This program is  free software; you can redistribute unmodified
    versions of it as long as you do not  profit from that, neither
    by selling it nor  by   including it  with other products   for
    sale.  This copyright  notice  must  remain in all  distributed
    copies.

    You are  allowed to modify your  personal copy  of this program
    (as long as you do not distribute any changed versions).

    You may,  of course, distribute  along with it, your own source
    code or libraries of algorithms that run under GeoLab.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.

    If you must contact the authors, you may write to:
                     geolab-request@dcc.unicamp.br
*/

/*
 * Kernel.h - implementacao do algoritmo para o calculo do kernel (nucleo) de
 *            um poligono simples.
 * 
 *
 *    	Data	Hora  	Nome     		Modificacao/Motivo
 *
 *    24.04.92  09:30 	Welson R. Jacometti  	Arquivo criado
 *
 */

#ifndef _KERNEL_DEFINED
#define _KERNEL_DEFINED
 
#include "External.h"		// obrigatorio a todo modulo externo
#include "Algorithm.h"
#include "Point2D.h"
#include "Polygon.h"

#ifndef _Point2D_ptr_list
#define _Point2D_ptr_list
declare(list,Point2D_ptr)
#endif ~_Point2D_ptr_list;

/*
 * Kernel of a simple polygon
 *
 */
 
list(Point2D_ptr) kernel_simple_polygon(list(Point2D_ptr) &points, World *w = 0, int animation_depth = 0, int reference_depth = 0);

// Modelagem

class Kernel : public Algorithm {
  public:
    bool animation() { return true; }

    bool is_able_to_handle(const SelectedObjects &, const GraphicObjects &);

    ResultObjects binder(const SelectedObjects &, const GraphicObjects &, World *w = 0, int animation_depth = 0, int reference_depth = 0);
};

Algorithm* kernel_simple_polygon_link();

#endif ~_KERNEL_DEFINED;





