/*
    Copyright (C) 1992-1994
                    Welson R. Jacometti

    All rights reserved.

    This program is  free software; you can redistribute unmodified
    versions of it as long as you do not  profit from that, neither
    by selling it nor  by   including it  with other products   for
    sale.  This copyright  notice  must  remain in all  distributed
    copies.

    You are  allowed to modify your  personal copy  of this program
    (as long as you do not distribute any changed versions).

    You may,  of course, distribute  along with it, your own source
    code or libraries of algorithms that run under GeoLab.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.

    If you must contact the authors, you may write to:
                     geolab-request@dcc.unicamp.br
*/

/*
 * Line2D_test.C
 *
 *
 *    	Data	Hora  	Nome     		Modificacao/Motivo
 *
 *    20.01.92  13:40 	Welson	 	  	Arquivo criado
 *
 */

#include "Line2D_test.h"
#include "Boolean.h"

bool intersect_line(Line2D_ptr &l1, Line2D_ptr &l2) {
    return l1->intersect(*l2);
}

Point2D intersection_line(Line2D_ptr &l1, Line2D_ptr &l2) {
    return l1->intersection(*l2);
}

/*
 * implementacao dos metodos
 *
 */
 
bool intersect_lines::is_able_to_handle(const SelectedObjects &SO, const GraphicObjects &GO) {
    list_item it;
    int nl = 0;
    
    forall(it, SO) {
      if (GO[it]->type() != Line2D_t) {
      	SO.init_iterator();
      	return false;
      }
      else
        nl++;
    }
    
    if (nl == 2)
      return true;
    else
      return false;
}

ResultObjects intersect_lines::binder(const SelectedObjects& SO, const GraphicObjects& GO, World *, int, int) {
    ResultObjects Result;
    Line2D_ptr l1, l2;
    list_item it = SO.first();
    Boolean* Bool_ptr;

    if (!SO.empty()) {
      l1 = (Line2D_ptr)GO[SO[it]]->obj;
      l2 = (Line2D_ptr)GO[SO[SO.succ(it)]]->obj;
      Bool_ptr = new Boolean (intersect_line(l1, l2));
      Bool_ptr->obj_volatile(true);
      Result.push(Bool_ptr);
    }

    return Result;
}

ResultObjects intersection_lines::binder(const SelectedObjects& SO, const GraphicObjects& GO, World *, int, int) {
    ResultObjects Result;
    Line2D_ptr l1, l2;
    list_item it = SO.first();
    Point2D_ptr p;
   
    if (!SO.empty()) {
      l1 = (Line2D_ptr)GO[SO[it]]->obj;
      l2 = (Line2D_ptr)GO[SO[SO.succ(it)]]->obj;
      if (l1->intersect(*l2)) {
        p = new Point2D(intersection_line(l1, l2));
        Result.push(p);
      }
    }

    return Result;
}

Algorithm* intersect_lines_link() {
    return new intersect_lines();
}

Algorithm* intersection_lines_link() {
    return new intersection_lines();
}



