/*
    Copyright (C) 1992-1994
                    Welson R. Jacometti

    All rights reserved.

    This program is  free software; you can redistribute unmodified
    versions of it as long as you do not  profit from that, neither
    by selling it nor  by   including it  with other products   for
    sale.  This copyright  notice  must  remain in all  distributed
    copies.

    You are  allowed to modify your  personal copy  of this program
    (as long as you do not distribute any changed versions).

    You may,  of course, distribute  along with it, your own source
    code or libraries of algorithms that run under GeoLab.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.

    If you must contact the authors, you may write to:
                     geolab-request@dcc.unicamp.br
*/

/*
 * Misc.h - algoritmos geometricos genericos e de baixo nivel para auxiliar
 *          no processo de animacao de algoritmos geometricos.
 * 
 *
 *    	Data	Hora  	Nome     		Modificacao/Motivo
 *
 *    24.04.92  09:30 	Welson R. Jacometti  	Arquivo criado
 *
 */

#ifndef _MISC_DEFINED
#define _MISC_DEFINED
 
#include "External.h"		// obrigatorio a todo modulo externo
#include "Algorithm.h"
#include "Point2D.h"

#ifndef _Point2D_ptr_list
#define _Point2D_ptr_list
declare(list,Point2D_ptr)
#endif ~_Point2D_ptr_list;

list_item it_get_min_Y( list(Point2D_ptr) &Points, World *w, int animation_depth, int reference_depth);
list_item it_lower_angle_ccw( list(Point2D_ptr) &Points,  Point2D &ref, World *w, int animation_depth, int reference_depth);

int winding_number( list(Point2D_ptr) &Points,  Point2D &ref, World *w = 0, int animation_depth = 0, int reference_depth = 0);

#endif ~_MISC_DEFINED;

