/*
 * This code has been modified for compatibility with other
 * source codes of GeoLab.
 */

/*******************************************************************************
+
+  LEDA  2.0.1                                                7/3/1991
+
+
+  partition.h
+
+
+  Copyright (c) 1991  by  Max-Planck-Institut fuer Informatik
+  Im Stadtwald, 6600 Saarbruecken, FRG     
+  All rights reserved.
+ 
*******************************************************************************/




#ifndef PARTITIONH
#define PARTITIONH

//------------------------------------------------------------------------------
// partition   (union find)
//
// Stefan Naeher  (1989)
//------------------------------------------------------------------------------

#include "basic.h"


class partition_node {

friend class partition;

partition_node* father;
partition_node* next;
int size;
ent contents;

public:

partition_node(ent x, partition_node* n)  
{ 
  father=0; size=1; contents=x; next = n; 
 }

OPERATOR_NEW(4)
OPERATOR_DEL(4)

};


// a partition item is a pointer to a partition node:

typedef partition_node* partition_item;



class partition {

partition_item used_items;                 // List of used partition items



public:  // operations 

void           union_blocks(partition_item,partition_item);

partition_item find(partition_item);

partition_item make_block(ent x = nil) 
{ used_items = new partition_node(x,used_items); 
  return used_items; 
 }

int  same_block(partition_item a, partition_item b) 
{ return find(a)==find(b); }

ent  contents(partition_item a) { return a->contents; }

void clear();                      // deletes all used items

 partition() { used_items = 0; }   // constructor
~partition() { clear();  }         // destructor 

};


#endif









