/*
    Copyright (C) 1992-1994
                    Cesar N. Gon

    All rights reserved.

    This program is  free software; you can redistribute unmodified
    versions of it as long as you do not  profit from that, neither
    by selling it nor  by   including it  with other products   for
    sale.  This copyright  notice  must  remain in all  distributed
    copies.

    You are  allowed to modify your  personal copy  of this program
    (as long as you do not distribute any changed versions).

    You may,  of course, distribute  along with it, your own source
    code or libraries of algorithms that run under GeoLab.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.

    If you must contact the authors, you may write to:
                     geolab-request@dcc.unicamp.br
*/

/*
 * Segment2D_test.h
 *
 *
 *    	Data	Hora  	Nome     		Modificacao/Motivo
 *
 *    20.01.92  13:40 	Cesar N. Gon 	  	Arquivo criado
 *
 */

#ifndef _SEGMENT2D_TEST_DEFINED
#define _SEGMENT2D_TEST_DEFINED

#include "External.h"		// obrigatorio a todo modulo externo
#include "Algorithm.h"
#include "Point2D.h"
#include "Segment2D.h"

#ifndef _Point2D_ptr_list
#define _Point2D_ptr_list
declare(list,Point2D_ptr)
#endif ~_Point2D_ptr_list;

#ifndef _Segment2D_ptr_list
#define _Segment2D_ptr_list
declare(list,Segment2D_ptr)
#endif ~_Segment2D_ptr_list;

/*
 * algoritmos
 *
 */
 
bool point_in_segm(Segment2D_ptr& s,Point2D_ptr& p);
bool intersect_segm(Segment2D_ptr& s1,Segment2D_ptr& s2);
Point2D intersection_segm(Segment2D_ptr& s1,Segment2D_ptr& s2);

// Modelagem dos algoritmos acima em termos do ambiente GeoLab 

class Segment2DTools : public Algorithm {
};

class point_in : public Segment2DTools {
  public:
    bool is_able_to_handle(const SelectedObjects &, const GraphicObjects &);
    ResultObjects binder(const SelectedObjects &, const GraphicObjects &, World *, int, int);
};

class intersect : public Segment2DTools {
  public:
    bool is_able_to_handle(const SelectedObjects &, const GraphicObjects &);
    ResultObjects binder(const SelectedObjects &, const GraphicObjects &, World *, int, int);
};

class intersection : public intersect {
  public:
    ResultObjects binder(const SelectedObjects &, const GraphicObjects &, World *, int, int);
};

Algorithm* point_in_link();
Algorithm* intersect_link();
Algorithm* intersection_link();

#endif ~_SEGMENT2D_TEST_DEFINED;






