/*
    Copyright (C) 1992-1994
                    Welson R. Jacometti

    All rights reserved.

    This program is  free software; you can redistribute unmodified
    versions of it as long as you do not  profit from that, neither
    by selling it nor  by   including it  with other products   for
    sale.  This copyright  notice  must  remain in all  distributed
    copies.

    You are  allowed to modify your  personal copy  of this program
    (as long as you do not distribute any changed versions).

    You may,  of course, distribute  along with it, your own source
    code or libraries of algorithms that run under GeoLab.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.

    If you must contact the authors, you may write to:
                     geolab-request@dcc.unicamp.br
*/

/*
 *
 * Square.C - Square & GraphicSquare methods.
 *
 *
 *    	Data	Hora  	Nome     		Modificacao/Motivo
 *
 *    07.01.92  13:40 	Welson R. Jacometti  	Arquivo criado
 *
 */

#include "Obj.h"
#include "Square.h"

GraphicObj* Square::new_GraphicObj() {
    return new GraphicSquare(this);
}

/*
 *
 *
 */

// cast macro

#define square ((Square *)obj)

// inherited methods redefinition

static Point2D pinit;

void GraphicSquare::int_start(World *, double initial_X, double initial_Y, Int_Mode mode) {
    if (mode == MiddleButton)
      pinit.setXY(initial_X, initial_Y);
      
    square->set(initial_X, initial_Y, initial_X, initial_Y);
}

void GraphicSquare::int_change(World *, double new_X, double new_Y, Int_Mode mode) {
    if (mode == LeftButton) {
      if (fabs(new_X - square->P1().X()) < fabs(new_Y - square->P1().Y()))
        if (new_Y > square->P1().Y())
          new_Y = square->P1().Y() + fabs(square->P1().X() - new_X);
        else
          new_Y = square->P1().Y() - fabs(square->P1().X() - new_X);
      else
        if (new_X > square->P1().X())
          new_X = square->P1().X() + fabs(square->P1().Y() - new_Y);
        else
          new_X = square->P1().X() - fabs(square->P1().Y() - new_Y);
      square->set(square->P1().X(), square->P1().Y(), new_X, new_Y);
    }
    else {
      double r = pinit.e_distance(Point2D(new_X, new_Y));
      double dr = sqrt((r * r) / 2);
      square->set(pinit.X() - dr, pinit.Y() - dr, pinit.X() + dr, pinit.Y() + dr);
     }
}

void GraphicSquare::int_end(World *w, double final_X, double final_Y, Int_Mode mode) {
    int_change(w, final_X, final_Y, mode);
}

void GraphicSquare::resize_start(World *w, double X, double Y, Int_Mode mode) {
    if (mode == MiddleButton)
      pinit.setXY((square->P1().X() + square->P2().X())/2, (square->P1().Y() + square->P2().Y())/2);
    GraphicRectangle::resize_start(w, X, Y, mode);
}


