/*
    Copyright (C) 1992-1994
                    Welson R. Jacometti

    All rights reserved.

    This program is  free software; you can redistribute unmodified
    versions of it as long as you do not  profit from that, neither
    by selling it nor  by   including it  with other products   for
    sale.  This copyright  notice  must  remain in all  distributed
    copies.

    You are  allowed to modify your  personal copy  of this program
    (as long as you do not distribute any changed versions).

    You may,  of course, distribute  along with it, your own source
    code or libraries of algorithms that run under GeoLab.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.

    If you must contact the authors, you may write to:
                     geolab-request@dcc.unicamp.br
*/

/*
 *
 * String.C - implementacao dos metodos da classe String.
 *
 *
 *    	Data	Hora  	Nome     		Modificacao/Motivo
 *
 *    19.11.91  13:40 	Welson R. Jacometti  	Arquivo criado
 *
 */

#include "String.h"

String::String(int ln) {
    assert(ln >= 0);
    len = ln;
    str = new char[len + 1];
    assert(str);
    for (int i = 0; i < len; i++)
      str[i] = ' ';
    str[len] = 0;
}

String::String(char *s) {
    if (!s)
      len = 0;
    else
      len = strlen(s);
    str = new char[len + 1];
    assert(str);
    if (s)
      strcpy(str, s);
    str[len] = 0;
}

String::String(const String &s) {
    len = s.len;
    str = new char[len + 1];
    assert(str);
    if (s.str)
      strcpy(str, s.str);    
    str[len] = 0;
}

String& String::operator = (const String &s) {
    if (str)
      delete str;
    len = s.len;
    str = new char[len + 1];
    assert(str);
    if (s.str)
      strcpy(str, s.str);
    str[len] = 0;
    return *this;
}

bool String::operator == (const String &s) const {
    if (str == s.str)
      return true;
    else
      if (len != s.len)
        return false;
      else
        return strcmp(str, s.str) == 0;
}

char* my_strcat(const char* s1, const char* s2) {
  char* res = new char[strlen(s1)+strlen(s2)+1];
  strcpy(res, s1);
  strcat(res, s2);
  return res;
}


String String::operator + (const String &s) const {
    char *s1, *s2;
    if (!str)
      s1 = '\0';
    else
      s1 = str;
    if (!s.str)
      s2 = '\0';
    else
      s2 = s.str;

    return String(my_strcat(s1, s2));
}



