/*
    Copyright (C) 1992-1994
                    Cesar N. Gon

    All rights reserved.

    This program is  free software; you can redistribute unmodified
    versions of it as long as you do not  profit from that, neither
    by selling it nor  by   including it  with other products   for
    sale.  This copyright  notice  must  remain in all  distributed
    copies.

    You are  allowed to modify your  personal copy  of this program
    (as long as you do not distribute any changed versions).

    You may,  of course, distribute  along with it, your own source
    code or libraries of algorithms that run under GeoLab.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.

    If you must contact the authors, you may write to:
                     geolab-request@dcc.unicamp.br
*/

/*
 * animation_tools.h
 *
 *
 *    	Data	Hora  	Nome     		Modificacao/Motivo
 *
 *    09.12.92  17:06 	Cesar N. Gon 	  	Arquivo criado
 *
 */

#include <assert.h>
#include <math.h>
#include "External.h"
#include "Obj.h"
#include "animation.h"
#include "Point2D.h"
#include "Segment2D.h"
#include "Circle.h"
#include "Line2D.h"
#include "Arrow2D.h"


// Control functions...

// anim_delay: suspends executions for msec miliseconds.
extern void anim_delay(World* w,unsigned int  msec);

//  # anim_move_object: move object "g_obj" along the vector (deltax,deltay).
//  speed(>0) controls the velocity. Hint: 80 is a "good" speed!!
//  (speed > 560) ==> (speed = maximum)  
extern void anim_move_object(World* w, GraphicObj* g_obj,double deltax, double deltay, double speed);



// Drawing functions....
  
void animation_tools_init(World *w);
void anim_show(World *w, GraphicPoint2D& p, double f);
void anim_show(World *w, Point2D& p, double);
void draw_blank (World *w, GraphicObj_ptr obj);
void show_arrow (World *w, Point2D& p1, Point2D& p2);
void show_segment (World *w, Point2D& p1, Point2D& p2);



