/*
    Copyright (C) 1992-1994
                    Welson R. Jacometti

    All rights reserved.

    This program is  free software; you can redistribute unmodified
    versions of it as long as you do not  profit from that, neither
    by selling it nor  by   including it  with other products   for
    sale.  This copyright  notice  must  remain in all  distributed
    copies.

    You are  allowed to modify your  personal copy  of this program
    (as long as you do not distribute any changed versions).

    You may,  of course, distribute  along with it, your own source
    code or libraries of algorithms that run under GeoLab.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.

    If you must contact the authors, you may write to:
                     geolab-request@dcc.unicamp.br
*/

/*
 *
 * handle.h - `handles' dos objetos geometricos.
 *
 *
 *    	Data	Hora  	Nome     		Modificacao/Motivo
 *
 *    19.11.91  13:40 	Welson R. Jacometti  	Arquivo criado
 *
 */

#ifndef _HANDLE_DEFINED
#define _HANDLE_DEFINED

#include <iostream.h>
#include "global.h"
#include "tools.h"
#include "World.h"

#define _HX	4
#define _HY	4

inline void draw_handle(World *w, GC gc, double X, double Y) {
    w->DrawRectangle(gc, X-_HX, Y-_HY, X+_HX, Y+_HY);
}
    
inline void fill_handle(World *w, GC gc, double X, double Y) {
    w->DrawRectangle(gc, X-_HX, Y-_HY, X+_HX, Y+_HY);
    w->FillRectangle(gc, X-_HX, Y-_HY, X+_HX, Y+_HY);
}

inline void draw_circular_handle(World *w, GC gc, double X, double Y) {
    w->DrawArc(gc, X-_HX, Y-_HY, X+_HX, Y+_HY);
}

inline void fill_circular_handle(World *w, GC gc, double X, double Y) {
    w->FillArc(gc, X-_HX, Y-_HY, X+_HX, Y+_HY);
}

void unfill_handle(World *w, double X, double Y);
void unfill_circular_handle(World *w, double X, double Y);

inline bool select_handle_test(double X, double Y, double px, double py) { 
    return range(X, px-_HX, px+_HX) && range(Y, py-_HY, py+_HY);  
}

inline bool select_handle_test(double X, double Y, double x1, double y1, double x2, double y2) {
    return range(X, x1, x2) && range(Y, y1, y2);
}

#endif ~_HANDLE_DEFINED









