/*
    Copyright (C) 1992-1994
                    Cesar N. Gon

    All rights reserved.

    This program is  free software; you can redistribute unmodified
    versions of it as long as you do not  profit from that, neither
    by selling it nor  by   including it  with other products   for
    sale.  This copyright  notice  must  remain in all  distributed
    copies.

    You are  allowed to modify your  personal copy  of this program
    (as long as you do not distribute any changed versions).

    You may,  of course, distribute  along with it, your own source
    code or libraries of algorithms that run under GeoLab.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.

    If you must contact the authors, you may write to:
                     geolab-request@dcc.unicamp.br
*/

/*
 *
 * input_tools.h - 
 *
 *             link flag -lm
 *
 *
 *    	Data	Hora  	Nome     		Modificacao/Motivo
 *
 *    13.02.92  07:49 	Cesar N. Gon  	         Arquivo criado
 *
 */

#ifndef _INPUT_TOOLS_DEFINED
#define _INPUT_TOOLS_DEFINED

#include <iostream.h>
#include "global.h"
#include "World.h"
#include "Obj.h"
#include "Point2D.h"

EXPORT int POLYGON_TYPE;
EXPORT int POLYGON_SELECTED;
EXPORT int POLYGON_DISCARD_INPUT;
EXPORT int POLYGON_UNSELECT_INPUT;
EXPORT int COVER_SELECTED;
EXPORT int COVER_DISCARD_INPUT;
EXPORT int COVER_SCALE;
EXPORT int COVER_POINTS;
EXPORT int COVER_UNSELECT_INPUT;
EXPORT int COVER_TIMEOUT;
EXPORT int RANDOM_POINTS_SELECTED;
EXPORT int RANDOM_POINTS_DISCARD_INPUT;
EXPORT int RANDOM_POINTS_SCALE;
EXPORT int RANDOM_POINTS_NUMBER;
EXPORT int RANDOM_POINTS_TIMEOUT;
EXPORT int RANDOM_POINTS_ALL_REGION;
EXPORT int RANDOM_POINTS_UNSELECT_INPUT;

void random_points_schedule (World *w);
void random_cover_schedule (World *w);
void random_polygon_schedule (World *w);
void randomize ();
Point2D random_point_in_box (double xmin, double ymin, double xmax, double ymax);
void put_warning_left (World *w, char *msg);
double random_value_in_interval (double a, double b);
void regularize_coords (double &x1, double &y1, double &x2, double &y2);

void print_selected_objects ();
void print_objects ();

#endif ~_INPUT_TOOLS_DEFINED







