/*
    Copyright (C) 1992-1994
                    Welson R. Jacometti

    All rights reserved.

    This program is  free software; you can redistribute unmodified
    versions of it as long as you do not  profit from that, neither
    by selling it nor  by   including it  with other products   for
    sale.  This copyright  notice  must  remain in all  distributed
    copies.

    You are  allowed to modify your  personal copy  of this program
    (as long as you do not distribute any changed versions).

    You may,  of course, distribute  along with it, your own source
    code or libraries of algorithms that run under GeoLab.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.

    If you must contact the authors, you may write to:
                     geolab-request@dcc.unicamp.br
*/

/*
 *
 * instantiation.h - modulo para regeneracao de objetos a partir de seus tipos.
 *
 *
 *    	Data	Hora  	Nome     		Modificacao/Motivo
 *
 *    26.09.91  18:25 	Welson R. Jacometti  	Arquivo criado
 *
 */

/*
 * IMPORTANTE:
 *
 *    O disparo de algoritmos externos e' feito unica e exclusivamente em
 *  dois modulos: algorithms.C(.h) e instantiation.C(.h) 
 *    Nestes modulos, antes da referencia ao algoritmo externo, DEVE ser
 *  feita a mudanca da rotina de tratamento de sinais, para que o usuario
 *  seja corretamente informado sobre problemas decorrentes a) do ambiente
 *  ou b) de um determinado algoritmo externo.
 *
 */
 
#ifndef _INSTANTIATION_DEFINED
#define _INSTANTIATION_DEFINED

#include <stdlib.h>
#include <dlfcn.h>
#include "global.h"
#include "Obj.h"

// Funcao geradora de objetos -> somente objetos 'conhecidos' pelo GeoLab.
// (objetos desconhecidos sao gerados pelas funcoes xxx_instantiation providas
// pelos algoritmos externos geradores de objetos desconhecidos)

Obj_ptr geolab_instantiation(ObjType t);

// Funcao que executa chamadas a algoritmos externos de forma a poder instanciar
// objetos desconhecidos e propiciar a implementacao de recursos como por 
// exemplo armazenamento em memoria secundaria.

Obj_ptr external_instantiation(ObjType t, char *function, char *module);

#endif ~_INSTANTIATION_DEFINED;






