/*
    Copyright (C) 1992-1994
                    Welson R. Jacometti

    All rights reserved.

    This program is  free software; you can redistribute unmodified
    versions of it as long as you do not  profit from that, neither
    by selling it nor  by   including it  with other products   for
    sale.  This copyright  notice  must  remain in all  distributed
    copies.

    You are  allowed to modify your  personal copy  of this program
    (as long as you do not distribute any changed versions).

    You may,  of course, distribute  along with it, your own source
    code or libraries of algorithms that run under GeoLab.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.

    If you must contact the authors, you may write to:
                     geolab-request@dcc.unicamp.br
*/

/*
 * proximity.h - algoritmos para problemas de proximidade.
 * 
 *
 *    	Data	Hora  	Nome     		Modificacao/Motivo
 *
 *    24.04.92  09:30 	Welson R. Jacometti  	Arquivo criado
 *
 */

#ifndef _PROXIMITY_DEFINED
#define _PROXIMITY_DEFINED
 
#include "External.h"		// obrigatorio a todo modulo externo
#include "Algorithm.h"
#include "Point2D.h"
#include "Segment2D.h"

#ifndef _Point2D_ptr_list
#define _Point2D_ptr_list
declare(list,Point2D_ptr)
#endif ~_Point2D_ptr_list;

#ifndef _Segment2D_ptr_list
#define _Segment2D_ptr_list
declare(list,Segment2D_ptr)
#endif ~_Segment2D_ptr_list;

// brute force
Segment2D_ptr closest_pair_bf(list(Point2D_ptr) &points, World *w = 0, int animation_depth = 0, int reference_depth = 0);
list(Segment2D_ptr) all_nearest_neighbors_bf(list(Point2D_ptr) &points, World *w = 0, int animation_depth = 0, int reference_depth = 0);


// Divide & Conquer
Segment2D_ptr closest_pair_dc(list(Point2D_ptr) &points, World *w = 0, int animation_depth = 0, int reference_depth = 0);
list(Segment2D_ptr) all_nearest_neighbors_dc(list(Point2D_ptr) &points, World *w = 0, int animation_depth = 0, int reference_depth = 0);
     

// using Voronoi diagram
Segment2D_ptr closest_pair_vd(list(Point2D_ptr) &points, World *w = 0, int animation_depth = 0, int reference_depth = 0);
list(Segment2D_ptr) all_nearest_neighbors_vd(list(Point2D_ptr) &points, World *w = 0, int animation_depth = 0, int reference_depth = 0);

#endif ~_PROXIMITY_DEFINED;



