/*
    Copyright (C) 1992-1994
                    Welson R. Jacometti

    All rights reserved.

    This program is  free software; you can redistribute unmodified
    versions of it as long as you do not  profit from that, neither
    by selling it nor  by   including it  with other products   for
    sale.  This copyright  notice  must  remain in all  distributed
    copies.

    You are  allowed to modify your  personal copy  of this program
    (as long as you do not distribute any changed versions).

    You may,  of course, distribute  along with it, your own source
    code or libraries of algorithms that run under GeoLab.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.

    If you must contact the authors, you may write to:
                     geolab-request@dcc.unicamp.br
*/

/*
 *
 * quit.C - funcao de termino de execucao do GeoLab.
 *
 *
 *    	Data	Hora  	Nome     		Modificacao/Motivo
 *
 *    08.10.91  21:25 	Welson R. Jacometti  	Arquivo criado
 *
 */

#include "quit.h"

bool TERMINATED = false;

void quit(Xv_opaque frame) {
    xv_destroy_safe(frame);
}

Notify_value interpose_quit(Notify_client client, Destroy_status status) {
    if (status == DESTROY_CHECKING) {
      int op = notice_prompt(client, NULL, 
    			NOTICE_MESSAGE_STRINGS,		"Do you really want to quit?",
    							NULL,
                        NOTICE_BUTTON_NO,		"Yes",
			NOTICE_BUTTON_YES,		"No",
			NULL);

      if (op == NOTICE_YES)
        notify_veto_destroy(client);
      else
       	TERMINATED = true;
    }
    else 
      if (status == DESTROY_CLEANUP)
        return notify_next_destroy_func(client, status);

    return NOTIFY_DONE;
}
