/*
    Copyright (C) 1992-1994
                    Cesar N. Gon

    All rights reserved.

    This program is  free software; you can redistribute unmodified
    versions of it as long as you do not  profit from that, neither
    by selling it nor  by   including it  with other products   for
    sale.  This copyright  notice  must  remain in all  distributed
    copies.

    You are  allowed to modify your  personal copy  of this program
    (as long as you do not distribute any changed versions).

    You may,  of course, distribute  along with it, your own source
    code or libraries of algorithms that run under GeoLab.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.

    If you must contact the authors, you may write to:
                     geolab-request@dcc.unicamp.br
*/

/*
 * random_polygon.h
 *
 *
 *    	Data	Hora  	Nome     		Modificacao/Motivo
 *
 *    05.05.92  12:08 	Cesar N. Gon 	  	Arquivo criado
 *
 */

#ifndef _RANDOM_POLYGON_DEFINED
#define _RANDOM_POLYGON_DEFINED

#include "External.h"		// obrigatorio a todo modulo externo
#include "Algorithm.h"
#include "Polygon.h"

#ifndef _Point2D_ptr_list
#define _Point2D_ptr_list
declare(list,Point2D_ptr)
#endif ~_Point2D_ptr_list;

/*
 * algoritmos
 *
 */
 
class Random_Polygon : public Algorithm {
  public:
    bool is_able_to_handle(const SelectedObjects &, const GraphicObjects &);
};

class simple_polygon : public Random_Polygon {
  public:
    ResultObjects binder(const SelectedObjects &, const GraphicObjects &, World *, int, int);
};

class convex_polygon : public Random_Polygon {
  public:
    ResultObjects binder(const SelectedObjects &, const GraphicObjects &, World *, int, int);
};

class starshaped_polygon : public Random_Polygon {
  public:
    ResultObjects binder(const SelectedObjects &, const GraphicObjects &, World *, int, int);
};

class generic_polygon : public Random_Polygon {
  public:
    ResultObjects binder(const SelectedObjects &, const GraphicObjects &, World *, int, int);
};

Algorithm* simple_polygon_link();
Algorithm* convex_polygon_link();
Algorithm* starshaped_polygon_link();
Algorithm* generic_polygon_link();

#endif ~_RANDOM_POLYGON_DEFINED





