/*
    Copyright (C) 1992-1994
                    Welson R. Jacometti

    All rights reserved.

    This program is  free software; you can redistribute unmodified
    versions of it as long as you do not  profit from that, neither
    by selling it nor  by   including it  with other products   for
    sale.  This copyright  notice  must  remain in all  distributed
    copies.

    You are  allowed to modify your  personal copy  of this program
    (as long as you do not distribute any changed versions).

    You may,  of course, distribute  along with it, your own source
    code or libraries of algorithms that run under GeoLab.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.

    If you must contact the authors, you may write to:
                     geolab-request@dcc.unicamp.br
*/

/*
 * three_points_circle - Algoritmo que produz um circulo dados tres pontos.
 *
 *
 * Welson R. Jacometti
 *
 */

#ifndef _THREE_POINTS_CIRCLE_DEFINED
#define _THREE_POINTS_CIRCLE_DEFINED
 
#include "External.h"		// obrigatorio a todo modulo externo
#include "Algorithm.h"
#include "Point2D.h"
#include "Line2D.h"
#include "Circle.h"

Obj* circle_by_three_points(const Point2D &a, const Point2D &b, const Point2D &c);

// Modelagem do algoritmo acima em termos do ambiente GeoLab 

class three_points_circle : public Algorithm {
  public:
    bool is_able_to_handle(const SelectedObjects &, const GraphicObjects &);
    ResultObjects binder(const SelectedObjects &, const GraphicObjects &, World *, int, int);
};

Algorithm* three_points_circle_link();

#endif ~_THREE_POINTS_CIRCLE_DEFINED;
