/*
    Copyright (C) 1992-1994
                    Welson R. Jacometti

    All rights reserved.

    This program is  free software; you can redistribute unmodified
    versions of it as long as you do not  profit from that, neither
    by selling it nor  by   including it  with other products   for
    sale.  This copyright  notice  must  remain in all  distributed
    copies.

    You are  allowed to modify your  personal copy  of this program
    (as long as you do not distribute any changed versions).

    You may,  of course, distribute  along with it, your own source
    code or libraries of algorithms that run under GeoLab.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.

    If you must contact the authors, you may write to:
                     geolab-request@dcc.unicamp.br
*/

/*
 *
 * utilities.C - implementacao das funcoes auxiliares definidas em utilities.h
 *
 *
 *    	Data	Hora  	Nome     		Modificacao/Motivo
 *
 *    19.11.91  13:40 	Welson R. Jacometti  	Arquivo criado
 *
 */

#include "utilities.h"

#define DOUBLE_CLICK_TIME 200

void print_message(char *message_type, char *mn, char *fn, char *msg) {
    cout << message_type << ": " << mn << ": " << fn << ": " << msg << endl;
}
	
void error(char *module_name, char *function_name, char *message) {
    print_message("Fatal error", module_name, function_name, message);
    exit(1);
}

void warning(char *module_name, char *function_name, char *message) {
    print_message("Warning", module_name, function_name, message);
}


bool double_click(Event *event)
{
    static bool first = true;
    static struct timeval tdown_old;
    struct timeval tdown;
    bool ans;

    tdown.tv_sec  = event_time(event).tv_sec;
    tdown.tv_usec = event_time(event).tv_usec;

    if (first) {	
	first = false;
	ans = false;
    }
    else 
      ans = (diftime(tdown_old, tdown) <= DOUBLE_CLICK_TIME);

    tdown_old = tdown;
    return ans;
}


/*
 * diftime() - calcula a diferenca (mili segundos) entre dois intervalos
 *	       de tempo. 
 *
 */
 
long diftime(struct timeval t1, struct timeval t2)

{
    long dif;

    dif = (t2.tv_sec - t1.tv_sec) * 1000 + (t2.tv_usec - t1.tv_usec) / 1000; 
    return dif;
}




